package com.edgec.browserbackend.domain.account;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class AccountDto {

    private String name;

    private String password;

    private List<AccountDto> child;

    private Date lastSeen;

    private String email;

    private String fullname;

    private String companyName;

    private String jobTitle;

    private String phoneNumber;

    private String country;

    private String province;

    private boolean allowedToCreateSubUser;

    private boolean allowedToCreateCloudAccount;

    private List<CloudAccountDto> cloudAccounts;

    private int balance;

    private boolean isPrePaid = true;

    private boolean isVpsUser = false;

    private String parent;

    private String realName;

    private String idCard;

    private String token;

    public AccountDto(){

    }

    public AccountDto(Account account) {
        this.setName(account.getName());
        this.setAllowedToCreateSubUser(account.isAllowedToCreateSubUser());
        this.setAllowedToCreateCloudAccount(account.isAllowedToCreateCloudAccount());
        this.setCompanyName(account.getCompanyName());
        this.setCountry(account.getCountry());
        this.setEmail(account.getEmail());
        this.setFullname(account.getFullname());
        this.setJobTitle(account.getJobTitle());
        this.setPhoneNumber(account.getPhoneNumber());
        this.setProvince(account.getProvince());
        this.setUserServices(account.getUserServices());
        this.setParent(account.getParent());
        this.setRealName(account.getRealName());
        this.setIdCard(account.getIdCard());
        this.setToken(account.getToken());
    }

    public boolean isVpsUser() {
        return isVpsUser;
    }

    public void setVpsUser(boolean vpsUser) {
        isVpsUser = vpsUser;
    }

    public boolean isPrePaid() {
        return isPrePaid;
    }

    public void setPrePaid(boolean prePaid) {
        isPrePaid = prePaid;
    }

    public int getBalance() {
        return balance;
    }

    public void setBalance(int balance) {
        this.balance = balance;
    }

    private List<UserService> userServices = new ArrayList<>();

    public List<UserService> getUserServices() {
        return userServices;
    }

    public void setUserServices(List<UserService> userServices) {
        this.userServices = userServices;
    }

    public List<CloudAccountDto> getCloudAccounts() {
        return cloudAccounts;
    }

    public void setCloudAccounts(List<CloudAccountDto> cloudAccounts) {
        this.cloudAccounts = cloudAccounts;
    }


    public boolean isAllowedToCreateCloudAccount() {
        return allowedToCreateCloudAccount;
    }

    public void setAllowedToCreateCloudAccount(boolean allowedToCreateCloudAccount) {
        this.allowedToCreateCloudAccount = allowedToCreateCloudAccount;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public List<AccountDto> getChild() {
        return child;
    }

    public void setChild(List<AccountDto> child) {
        this.child = child;
    }

    public Date getLastSeen() {
        return lastSeen;
    }

    public void setLastSeen(Date lastSeen) {
        this.lastSeen = lastSeen;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getFullname() {
        return fullname;
    }

    public void setFullname(String fullname) {
        this.fullname = fullname;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getJobTitle() {
        return jobTitle;
    }

    public void setJobTitle(String jobTitle) {
        this.jobTitle = jobTitle;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public boolean isAllowedToCreateSubUser() {
        return allowedToCreateSubUser;
    }

    public void setAllowedToCreateSubUser(boolean allowedToCreateSubUser) {
        this.allowedToCreateSubUser = allowedToCreateSubUser;
    }

    public String getParent() {
        return parent;
    }

    public void setParent(String parent) {
        this.parent = parent;
    }

    public String getRealName() {
        return realName;
    }

    public void setRealName(String realName) {
        this.realName = realName;
    }

    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }
}
